<template>
	<v-dialog v-model="showForm" persistent max-width="400">
		<v-snackbar v-model="snackSucc" class="subtitle-1" top color="#72a051">Contraseña actualizada</v-snackbar>
		<v-snackbar
			v-model="snackErr"
			class="subtitle-1"
			top
			color="#c51f2f"
			:timeout="timeout"
		>{{msgErr}}</v-snackbar>
		<v-form v-model="isValid" ref="formPass">
			<v-card>
				<v-card-title>Actualizar contraseña</v-card-title>
				<v-card-text>
					<v-row>
						<v-col cols="12">
							<v-text-field
								v-model="pass.oldPassword"
								prepend-icon="fas fa-key"
								:append-icon="
									oldPass ? 'fa-eye' : 'fa-eye-slash'
								"
								:type="oldPass ? 'text' : 'password'"
								@click:append="oldPass = !oldPass"
								:rules="rulesPass"
								required
								outlined
								label="Antigua contraseña"
							/>
						</v-col>
						<v-col cols="12">
							<v-text-field
								v-model="pass.newPassword"
								prepend-icon="fas fa-key"
								:append-icon="
									newPass ? 'fa-eye' : 'fa-eye-slash'
								"
								:type="newPass ? 'text' : 'password'"
								@click:append="newPass = !newPass"
								:rules="rulesPass"
								outlined
								label="Nueva contraseña"
							/>
						</v-col>
						<v-col cols="12">
							<v-text-field
								v-model="modelComparePass"
								prepend-icon="fas fa-key"
								:append-icon="
									comparePass ? 'fa-eye' : 'fa-eye-slash'
								"
								:type="comparePass ? 'text' : 'password'"
								@click:append="comparePass = !comparePass"
								:rules="confirmPass"
								outlined
								label="Confirmar contraseña"
							/>
						</v-col>
					</v-row>
					<v-row>
						<v-col cols="12" sm="12">
							<v-btn :disabled="!isValid" outlined block color="green" @click="changePassword">Aceptar</v-btn>
						</v-col>
						<v-col>
							<v-btn outlined block color="red" @click="closeFormPass">Cancelar</v-btn>
						</v-col>
					</v-row>
				</v-card-text>
			</v-card>
		</v-form>
	</v-dialog>
</template>

<script>
import EventBus from "../../bus";
import gql from "graphql-tag";
import { mapActions } from "vuex";

export default {
	name: "FormChangePass",
	props: ["showForm"],
	data: () => ({
		isValid: true,
		timeout: 2000,
		snackSucc: false,
		snackErr: false,
		msgErr: "",
		oldPass: false,
		newPass: false,
		comparePass: false,
		pass: {
			oldPassword: "",
			newPassword: ""
		},
		modelComparePass: "",
		rulesPass: [
			value => !!value || "Campo requerido",
			value => (value || "").length >= 8 || "Mínimo 8 carácteres"
		]
	}),
	computed: {
		// Verifica ambas contraseñas sean correctas
		confirmPass() {
			return [
				this.pass.newPassword === this.modelComparePass ||
					"La contraseña no coincide"
			];
		}
	},
	methods: {
		...mapActions(["changePassword"]),
		// emite el EventBus que cierra el form
		closeFormPass() {
			EventBus.$emit("closeFormPass");
			this.$refs.formPass.reset();
		},
		async changePassword() {
			try {
				const { data } = await this.$apollo.mutate({
					mutation: gql`
						mutation($oldPassword: String!, $newPassword: String!) {
							changePassword(
								oldPassword: $oldPassword
								newPassword: $newPassword
							)
						}
					`,
					variables: {
						oldPassword: this.pass.oldPassword,
						newPassword: this.pass.newPassword
					}
				});
				switch (data.changePassword) {
					case "Clave incorrecta":
						this.msgErr = data.changePassword;
						this.snackErr = true;
						break;
					case "La nueva clave no puede ser igual a la anterior":
						this.msgErr = data.changePassword;
						this.snackErr = true;
						break;
					case "Password changed!":
						this.snackSucc = true;
						setTimeout(() => {
							this.snackSucc = false;
							this.closeFormPass();
						}, 2000);
				}
			} catch (error) {}
		}
	},
	mounted() {
		// cierra el formulario de registro con la tecla ESC
		document.addEventListener("keydown", event => {
			const keyWhich = event.which;
			if (keyWhich == 27) {
				this.closeFormPass();
			}
		});
	}
};
</script>
